{******************************************************
 *                                                    *
 *    Hilfsprogramm ALONLAT.PAS v1.1 zu SAT-Master    *
 *                                                    *
 ******************************************************}
{$A+,L-,R-,S-,I+,F-,O-,N+,E+,L-,V+,B-,M 10240 0 655360}
program alonlat;
uses  crt, mathe;
const version   : string[4] = '1.1';
      copyright : string[10] = 'DB1HZ 1991';
      teststr   : array[1..14] of string[18] =
         ('SATELLITE:','EPOCH TIME:','INCLINATION:',
          'RA OF NODE:','ECCENTRICITY:','ARG OF PERIGEE:',
          'MEAN ANOMALY:','MEAN MOTION:','DECAY RATE:',
          'EPOCH REV:','ALON:','ALAT:','AA:','DA:');

var   key : char;
      tag, monat, jahr : word;
      bm, alon, alat, aa, da,
      epoch, incl, raan, argper, mm, ecc,
      nalon, nalat, nepoch, nraan, nargper, nutc : extended;
      filename : string;
      zeile : array[1..12] of string[64];
      fehler : boolean;

function normwinkel(wert:extended):extended;
begin
  if wert>360 then wert:=360*frac(wert/360);
  while wert<0 do wert:=wert+360;
  normwinkel:=wert
end;

procedure loaddata;
var  i  : byte;
     f  : text;

  function rd(a:byte):extended;
  var v : extended;
      b : string;
      e : integer;
      i : byte;
  begin
    b:='';
    if pos(teststr[a],zeile[a])=0 then begin
      for i:=1 to 12 do begin
        if pos(teststr[i],zeile[a])>0 then begin
          b:=zeile[i];
          i:=12
        end
      end
    end else b:=zeile[a];
    if b='' then fehler:=true else begin
      if pos(':',b)>0 then delete(b,1,succ(pos(':',b)));
      while (b[1]=' ') and (length(b)>0) do delete(b,1,1);
      val(b,v,e);
      if e>0 then fehler:=true else rd:=v
    end
  end;

begin
  assign(f,filename);
  reset(f);
  if ioresult=0 then begin
    for i:=1 to 12 do if not eof(f) then readln(f,zeile[i])
  end else fehler:=true;
  close(f);
  if not fehler then begin
    for i:=1 to 12 do begin
      if zeile[i]='' then begin
        fehler:=true;
        i:=12
      end
    end
  end;
  if not fehler then epoch:=rd(2);
  if not fehler then incl:=rd(3);
  if not fehler then raan:=rd(4);
  if not fehler then ecc:=rd(5);
  if not fehler then argper:=rd(6);
  if not fehler then mm:=rd(8)
end;

function kplstr(s:string):string;
begin
  while length(s)<18 do s:=s+' ';
  kplstr:=s
end;

procedure savedata;
var  a : byte;
     f : text;
begin
  assign(f,filename);
  reset(f);
  close(f);
  if ioresult=0 then begin
    erase(f);
    assign(f,filename);
    rewrite(f);
    if ioresult=0 then begin
      for a:=1 to 10 do writeln(f,zeile[a]);
      writeln(f,kplstr(teststr[11]),alon:4:3);
      writeln(f,kplstr(teststr[12]),alat:4:3);
      writeln(f,kplstr(teststr[13]),aa:4:3);
      writeln(f,kplstr(teststr[14]),da:4:3)
    end else writeln('Der File ',filename,' lt sich nicht ffnen.');
    close(f)
  end else writeln('Der File ',filename,' lt sich nicht lschen.')
end;

procedure input;
begin
  write(' ALON : ');
  readln(nalon);
  write(' ALAT : ');
  readln(nalat);
  write(' Tag  : ');
  readln(tag);
  write(' Monat: ');
  readln(monat);
  write(' Jahr : 19');
  readln(jahr);
  writeln;
  write(' UTC  : ');
  readln(nutc);
  writeln;
end;

procedure berech;
var j : integer;
    i, si, ci, alo, ala, draan, dargper, a, b, c, z, n, dt : extended;
begin
  i:=incl*bm;
  si:=sin(i);
  ci:=cos(i);
  ala:=nalat*bm;
  alo:=nalon*bm;

    {EpochTime von aLON und aLAT berechnen}
  case monat of
    0 : nepoch:=tag;
    1 : nepoch:=tag;
    2 : nepoch:=tag+31;
    3 : nepoch:=tag+59;
    4 : nepoch:=tag+90;
    5 : nepoch:=tag+120;
    6 : nepoch:=tag+151;
    7 : nepoch:=tag+182;
    8 : nepoch:=tag+212;
    9 : nepoch:=tag+243;
   10 : nepoch:=tag+273;
   11 : nepoch:=tag+304;
   12 : nepoch:=tag+334;
  end;
  if monat>2 then if not (0=jahr and 3) or (jahr=2000) then nepoch:=nepoch+1;
  nepoch:=nepoch+nutc/24;

    {dRAAN und dArgPer pro Tag berechnen}
  a:=hoch(mm,7/3);
  n:=1-ecc*ecc;
  n:=n*n;
  z:=a*ci;
  draan:=-0.01331*z/n;
  z:=a*(5*ci*ci-1);
  dargper:=0.006642*z/n;

    {Differenzzeit berechnen}
  a:=epoch/1000;
  j:=round(a);
  if j<80 then j:=j+100;     { Jahr>=2000 }
  b:=1000*frac(a);
  while j<>jahr do begin
    if j<jahr then begin
      nepoch:=nepoch+365;
      dec(jahr);
      if (0=jahr and 3) then nepoch:=nepoch+1
    end else begin
      nepoch:=nepoch-365;
      if (0=jahr and 3) then nepoch:=nepoch-1;
      inc(jahr)
    end
  end;
  dt:=nepoch-b;

    {RAAN und ArgPer anpassen}
  nraan:=dt*draan+raan;
  while nraan>=360 do nraan:=nraan-360;
  nargper:=dt*dargper+argper;
  while nargper>=360 do nargper:=nargper-360;

    {nALON und nALAT nach AA und DA transformieren}
  c:=(450-nargper-nalon)*bm;
  a:=ci*sin(ala)+si*cos(ala)*cos(c);
  da:=arcsin(a)/bm;                   { <--- !!! '/bm' fehlte !!!}
  b:=arccos((sin(ala)-ci*a)/(si*cos(da*bm)))/bm;   {hier war auch ein Fehler!}
  if sin(c)<0 then b:=360-b;          { <--- !!! Diese Zeile fehlte !!!}
  aa:=normwinkel(b+nraan-90);

    {AA und DA nach ALON und ALAT transformieren}
  c:=90+aa-raan;
  a:=ci*sin(da*bm)+si*cos(da*bm)*cos(c*bm);
  alat:=arcsin(a)/bm;                 { <-- !!! '/bm' fehlte !!!}
  b:=arccos((sin(da*bm)-ci*a)/(si*cos(alat*bm)))/bm;
  if c>180 then b:=-b;
  alon:=normwinkel(450-argper-b)
end;

begin
  fehler:=false;
  bm:=3.14159265358789/180;
  clrscr;
  writeln(' SAT-Master Hilfsprogramm ALONLAT v',version,'   (C) ',copyright);
  writeln;
  if paramcount=1 then begin
    filename:=paramstr(1);
    if pos('.',filename)>0 then filename:=copy(filename,1,pred(pos('.',filename)));
    filename:=copy(filename,1,8)+'.SAT';
    loaddata;
    if not fehler then begin
      input;
      berech;
      savedata;
      writeln;
      writeln('ALON=',alon:3:9);
      writeln('ALAT=',alat:3:9);
      writeln('AA=',aa:3:9);
      writeln('DA=',da:3:9);
      writeln;
      writeln('File ',filename,' bearbeitet.')
    end else writeln('Fehler beim laden des Datensatzes ',filename)
  end else begin
    writeln(' ALONLAT dient zur Transformation von aLON und aLAT auf beliebige');
    writeln(' Bahndaten. Der Zeitpunkt der Lagedaten muss grob bekannt sein.');
    writeln(' Beim Aufruf wird der Name des Datensatzes, auf den die Lagedaten');
    writeln(' angepasst werden sollen, als Parameter uebergeben:');
    writeln;
    writeln('   ALONLAT <name(.SAT)>');
    writeln;
    writeln(' Die kommerzielle Nutzung dieses Programms ist untersagt.');
    writeln(' Die private Nutzung und Weitergabe ist gestattet.');
    writeln
  end;
  repeat until keypressed;
  while keypressed do key:=readkey
end.

