
{*************************************************
 *                                               *
 *    SAT-Master Hilfsprogramm AMSAT.PAS v 1.2   *
 *                                               *
 *************************************************}
{$A+,L-,R-,S-,I+,F-,O-,N+,E+,L-,V+,B-,M 4096 65536 655360}
program amsatt;

uses crt, antenne;

const version   : string[3] = '1.2';
      copyright : string[10] = 'DB1HZ 1991';
var   azimut, elevation, laenge, breite, zeitzone : extended;
      azz       : word;
      a         : char;

function key:char;
begin
  repeat until keypressed;
  key:=readkey
end;

procedure chkparam;
var  s : string;
begin
  s:=paramstr(1);
  if (s[1]='-') or (s[1]='/') then delete(s,1,1);
  if (upcase(s[1])='H') or (s[1]='?') then begin
    writeln('Dieses Programm dient dem Abgleich des AMSAT-Rotorinterface IF-100.');
    writeln;
    writeln('Der Aufruf erfolgt ohne Parameter. AMSAT ldt alle bentigten Daten aus der');
    writeln('Datei SAT.DAT im aktuellen Verzeichnis. Ist das Rotorinterface nicht akti-');
    writeln('viert, so bricht AMSAT mit eine Fehlermeldung ab. AMSAT testet nicht, ob sich');
    writeln('tatschlich ein Rotorinterface an der eingestellten Schnittstelle befindet.');
    writeln;
    writeln('Dieses Programm ist Bestandteil des Programmpaketes SAT-Master.')
  end
end;

procedure loaddata;
var  i : integer;
     f : text;
     d, s, s1, s2 : string;
     j : boolean;
     w : extended;
     k : array[1..9] of boolean;
     a : char;

  function del(a:string):string;
  begin
    if pos(':',a)>0 then delete(a,1,succ(pos(':',a)));
    while ((pos(' ',a)=1) or (pos(' ',a)=length(a))) and (length(a)>0)
     do delete(a,pos(' ',a),1);
    del:=a
  end;

begin
  amsat:=false;
  for i:=1 to 9 do k[i]:=false;
  {$I-}
  assign(f,'SAT.DAT');
  reset(f);
  if ioresult=0 then begin
    while not eof(f) do begin
      readln(f,s);
      if pos(':',s)>0 then begin
        d:=del(s);
        val(d,w,i);
        s:=copy(s,1,pred(pos(':',s)));
        if s='LAENGE' then begin
          laenge:=w;
          k[1]:=true
        end;
        if s='BREITE' then begin
          breite:=w;
          k[2]:=true
        end;
        if s='ZEITZONE' then begin
          zeitzone:=round(w);
          k[3]:=true
        end;
        if s='RECHTS' then begin
          rotor[1]:=round(w) and 255;
          k[4]:=true
        end;
        if s='LINKS' then begin
          rotor[2]:=round(w) and 255;
          k[5]:=true
        end;
        if s='OBEN' then begin
          rotor[3]:=round(w) and 255;
          k[6]:=true
        end;
        if s='UNTEN' then begin
          rotor[4]:=round(w) and 255;
          k[7]:=true
        end;
        if s='ANSCHLAG' then begin
          anschlag:=round(w);
          k[8]:=true
        end;
        if s='LPT' then begin
          lpt:=round(w-1) and 3;
          k[9]:=true
        end
      end else begin
        while (pos(' ',s)>0) and (length(s)>0) do delete(s,pos(' ',s),1);
        if s='AMSAT' then amsat:=true
      end
    end
  end else begin
    writeln('SAT.DAT im aktuellen Verzeichnis nicht gefunden.');
    writeln('AMSAT abgebrochen...');
    halt(1)
  end;
  if not k[1] then laenge:=10;
  if not k[2] then breite:=53.5;
  if not k[3] then zeitzone:=0;
  if amsat then begin
    if not k[4] then rotor[1]:=255;
    if not k[5] then rotor[2]:=0;
    if not k[6] then rotor[3]:=127;
    if not k[7] then rotor[4]:=0;
    if not k[8] then anschlag:=180;     {default: Sued}
    if not k[9] then lpt:=1             {default: LPT2}
  end;
  close(f);
  {$I+}
  i:=ioresult
end;

procedure setant;
var i : extended;
    j : word;
begin
  ant(azimut,elevation);
  gotoxy(37,17);
  write(round(azimut),'  ');
  gotoxy(37,19);
  write(round(elevation),' ');
  i:=(azimut-anschlag)/360;
  if i<0 then i:=i+1;
  if rotor[1]>rotor[2] then i:=rotor[2]+(rotor[1]-rotor[2])*i
   else i:=rotor[1]+(rotor[2]-rotor[1])*i;
  j:=round(i);
  if j>255 then j:=j-256;
  gotoxy(52,17);
  write(j,'  ');             { Horizontal }
  i:=elevation/90;
  if rotor[3]>rotor[4] then i:=rotor[4]+(rotor[3]-rotor[4])*i
   else i:=rotor[3]+(rotor[4]-rotor[3])*i;
  j:=round(i);
  if j>255 then j:=j-256;
  gotoxy(52,19);
  write(j,' ')               { Vertikal }
end;

procedure status;
const b : string[16] = '0123456789ABCDEF';
var   s : string;
      i : real;
      j : integer;
begin
  gotoxy(1,3);
  write('Abgleich des Rotorinterface IF-100');
  gotoxy(2,6);
  write('Anschlag bei ',anschlag,' Grad');
  gotoxy(35,6);
  write('LPT = ',lpt+1);
  s:=b[1+(druckport shr 12) and 15];
  s:=s+b[1+(druckport shr 8) and 15];
  s:=s+b[1+(druckport shr 4) and 15];
  s:=s+b[1+druckport and 15];
  s:='Adresse = $'+s;
  gotoxy(52,6);
  writeln(s);
  writeln;
  i:=rotor[1];
  write(' Anschlag RECHTS = ',rotor[1]);
  j:=(round(360*i/255)+anschlag) mod 360;
  gotoxy(25,8);
  writeln('- das sind ',j,' Grad');
  i:=rotor[2];
  write(' Anschlag LINKS  = ',rotor[2]);
  j:=(round(360*i/255)+anschlag) mod 360;
  gotoxy(25,9);
  writeln('- das sind ',j,' Grad');
  write(' Anschlag OBEN   = ',rotor[3]);
  gotoxy(25,10);
  writeln('- das sind 90 Grad');
  writeln(' Anschlag UNTEN  = ',rotor[4]);
  gotoxy(25,11);
  writeln('- das sind 0 Grad');
  gotoxy(24,17);
  write('Azimut.....:');
  gotoxy(24,19);
  write('Elevation..:');
  gotoxy(44,17);
  write('Rotor :');
  gotoxy(44,19);
  write('Rotor :')
end;

procedure menue;
begin
  repeat
    setant;
    gotoxy(20,23);
    write('steuern mit Cursortasten - abbrechen mit ESCape');
    repeat until keypressed;
    a:=key;
    if a=#0 then begin
      a:=key;
      case a of
        #27 : a:=#0;
        #77 : if azz<360 then begin
                inc(azz);
                azimut:=azimut+1;
                if not (azimut<360) then azimut:=azimut-360;
                setant
              end;
        #75 : if azz>0 then begin
                dec(azz);
                azimut:=azimut+359;
                if not (azimut<360) then azimut:=azimut-360;
                setant
              end;
        #72 : if round(elevation)<90 then begin
                elevation:=elevation+1;
                setant
              end;
        #80 : if round(elevation)>0 then begin
                elevation:=elevation-1;
                setant
              end
      end
    end;
  until a=#27
end;

procedure init;
begin
  druckport:=mem[$40:lpt*2+8]+256*mem[$40:lpt*2+9];
  druckport:=druckport and $3FF;   {auf 3FFh maskieren}
  if (druckport<$200) then begin
    if druckport=0 then writeln('LPTadresse nicht definiert.')
    else writeln('LPTadresse unter 200h gefunden.');
    writeln;
    writeln('AMSAT aus Sicherheitsgrnden abgebrochen...');
    halt(1)
  end;
  port[druckport]:=0;
  azimut:=(180+anschlag) mod 360;
  elevation:=45;
  azz:=180
end;

begin
  clrscr;
  writeln('SAT-Master Hilfsprogramm AMSAT v',version,'   (C) ',copyright);
  writeln;
  if paramcount>0 then chkparam else begin
    loaddata;
    if amsat then begin
      init;
      status;
      menue;
      clrscr
    end else begin
      writeln('Das AMSAT-Rotorinterface ist nicht aktiviert.');
      writeln;
      writeln('AMSAT abgebrochen...')
    end
  end;
end.


