{************************************************
 *                                              *
 *    SAT-Master v1.75  Grafik-Unit GRAPH.PAS   *
 *                                              *
 ************************************************}
{$A+,O-,L+,R+,S+,I+,F-,N+,E+,L+,V+,B+,M 16000 0 655360}
unit graph2;
interface
uses   dos, crt, graph;

const  herc                : boolean = false;
       bgimodus            : integer = 0;
       bginame             : string[8] = '';
var    vga, svga, winerror : boolean;
       uz, offset          : byte;
       winmaxx, winmaxy    : word;

function getpalette(p:byte):byte;
procedure grwritexy(curx,cury:byte;text:string;palf:byte);
procedure setpixel(x,y:integer; f:word);
procedure openwindow(x1,y1,x2,y2:integer;tattr,fattr,rattr:byte);
procedure closewindow;
procedure setrelativviewport(x1,y1,x2,y2:integer);
procedure clearrelativviewport;
procedure setgraph;
procedure delline(x1,y1,x2:integer);
procedure fastline(x1,y1,x2:integer);
procedure fastblock(y1,y2:word);
procedure delchar(x1,y1:word);

implementation

var    wincount     : byte;
       winmem       : array[1..4] of pointer;
       winsize      : array[1..4] of word;
       winxy        : array[0..4,1..4] of integer;
       wincolor     : array[0..3,1..2] of byte;

function getpalette(p:byte):byte;
var  regs  : registers;
begin
  regs.AX:=$1007;
  regs.BL:=p;
  intr(16,regs);
  getpalette:=regs.BH
end;

procedure egavgatreiber; external; {$L egavga.obj}

procedure grwritexy(curx,cury:byte;text:string;palf:byte);
var  regs : registers;
begin
  regs.AH:=2;
  regs.BH:=0;
  regs.DL:=pred(curx);
  regs.DH:=pred(cury);
  intr(16,regs);
  regs.AH:=3;
  regs.BX:=0;
  intr(16,regs);
  regs.AX:=4865;
  regs.BL:=palf;
  regs.CX:=length(text);
  regs.ES:=seg(text[1]);
  regs.BP:=ofs(text[1]);
  intr(16,regs)
end;

procedure setpixel(x,y:integer; f:word);
var  regs : registers;
begin
  regs.AH:=12;
  regs.BH:=0;
  regs.DX:=y;
  regs.CX:=x;
  regs.AL:=lo(f);
  intr(16,regs)
end;

procedure openwindow(x1,y1,x2,y2:integer;tattr,fattr,rattr:byte);
var x, y : integer;
    size : word;
begin
  if wincount<4 then begin
    size:=imagesize(x1,y1,x2,y2);
    x:=y2-y1-10;
    y:=x2-x1-10;
    if (maxavail<size) or (x<0) or (y<0) or (x1<0) or (x1>getmaxx) or
       (y1<0) or (y1>getmaxy) or (x2<0) or (x2>getmaxx) or (y2<0) or
       (y2>getmaxy) then winerror:=true else begin
      winerror:=false;
      setviewport(winxy[0,1],winxy[0,2],winxy[0,3],winxy[0,4],clipon);
      wincolor[wincount,1]:=getbkcolor;
      wincolor[wincount,2]:=getcolor;
      inc(wincount);
      winxy[wincount,1]:=x1;
      winxy[wincount,2]:=y1;
      winxy[wincount,3]:=x2;
      winxy[wincount,4]:=y2;
      winsize[wincount]:=size;
      getmem(winmem[wincount],winsize[wincount]);
      getimage(x1,y1,x2,y2,winmem[wincount]^);
      setviewport(x1,y1,x2,y2,clipon);
      winmaxx:=x;
      winmaxy:=y;
      x:=x2-x1-2;
      y:=y2-y1-2;
      setcolor(rattr);
      setbkcolor(fattr);
      clearviewport;
      line(2,2,x,2);
      line(x,2,x,y);
      line(x,y,2,y);
      line(2,y,2,2);
      setcolor(tattr);
      setviewport(x1+5,y1+5,x2-5,y2-5,clipon)
    end
  end
end;

procedure closewindow;
var  x1,y1,x2,y2 : integer;
begin
  if wincount>0 then begin
    setviewport(winxy[wincount,1],winxy[wincount,2],winxy[wincount,3],
                winxy[wincount,4],clipon);
    putimage(0,0,winmem[wincount]^,0);
    freemem(winmem[wincount],winsize[wincount]);
    dec(wincount);
    x1:=winxy[wincount,1];
    y1:=winxy[wincount,2];
    x2:=winxy[wincount,3];
    y2:=winxy[wincount,4];
    if wincount>0 then begin
      x1:=x1+5;
      y1:=y1+5;
      x2:=x2-5;
      y2:=y2-5;
      winmaxx:=x2-x1;
      winmaxy:=y2-y1
    end;
    setviewport(x1,y1,x2,y2,clipon);
    setbkcolor(wincolor[wincount,1]);
    setcolor(wincolor[wincount,2])
  end
end;

procedure setrelativviewport(x1,y1,x2,y2:integer);
var i1, i2 : integer;
begin
  i1:=winxy[wincount,1]+5;
  i2:=winxy[wincount,2]+5;
  if (x1<0) or (x2<0) or not (x1<x2) or (y1<0) or (y2<0) or not (y1<y2)
   then winerror:=true else begin
    setviewport(x1+i1,y1+i2,x2+i1,y2+i2,clipon);
    winmaxx:=x2-x1;
    winmaxy:=y2-y1
  end
end;

procedure clearrelativviewport;
var x1, y1, x2, y2 : integer;
begin
  x1:=winxy[wincount,1]+5;
  y1:=winxy[wincount,2]+5;
  x2:=winxy[wincount,3]-5;
  y2:=winxy[wincount,4]-5;
  setviewport(x1,y1,x2,y2,clipon);
  winmaxx:=x2-x1;
  winmaxy:=y2-y1
end;

procedure setgraph;
const ega1 : integer = 3;
      ega2 : integer = 1;
      vga1 : integer = 9;
      vga2 : integer = 2;
      bgi  : boolean = true;
var   regs : registers;
      noe  : byte;
      grdrv, grmode, bgitreiber : integer;
      param : string;
      c : char;

begin
  noe:=0;
  c:=chr(0);
  vga:=false;
  svga:=false;
  bgi:=false;
  if paramcount>0 then begin
    param:=copy(paramstr(1),1,2);
    if param[1]='/' then begin
      delete(param,1,1);
      if length(param)>0 then c:=upcase(param[1]);
      case c of
        'E' : ;
        'S' : svga:=true;
        'V' : vga:=true
        else c:=chr(0)
      end
    end
  end;
  if c=chr(0) then begin        {Grafikkarte testen}
    regs.AH:=18;         {EGA vorhanden?}
    regs.BL:=16;
    intr(16,regs);       {EGA-BIOS: EGA-Konfiguration (Monitor) ermitteln}
    if regs.BL=16 then noe:=1;
    if regs.BL<3 then noe:=2;
    if regs.CL<>9 then noe:=3;
    regs.AH:=$1A;        {VGA vorhanden?}
    regs.AL:=0;
    intr(16,regs);       {VGA-BIOS: Art der (emulierten) Videokarte ermitteln}
    if regs.AL=$1A then vga:=true;
    if (regs.BL<3) or (regs.BL=$FF) then noe:=1;
    if regs.BL=5 then noe:=3;
    if length(bginame)>0 then begin  {externer BGI spezifiziert?}
      bgi:=true;
    {$IFDEF VER60}     { Fehler in der GRAPH.TPU bis Version 5.5 }
      bgitreiber:=installuserdriver(bginame,nil);
    {$ELSE}
      bgitreiber:=installuserdriver(bginame,nil) +5 ;
    {$ENDIF}                                   { ^^ so zu beheben... }
      if graphresult<0 then noe:=8
    end
  end;
  if noe=0 then begin    {soweit OK...}
    if bgi then begin
      initgraph(bgitreiber,bgimodus,'');
      if graphresult<0 then noe:=7
    end else begin
      if svga then begin
        grdrv:=detect;
        initgraph(grdrv,grmode,'');
        if graphresult<0 then noe:=5
      end else begin
        if registerBGIdriver(@egavgatreiber)<0 then noe:=4 else begin
          if vga then initgraph(vga1,vga2,'') else initgraph(ega1,ega2,'');
          if graphresult<0 then noe:=6
        end
      end
    end
  end;
  if noe>0 then begin    {Fehler aufgetreten}
    case noe of
      1 : writeln('Dieses Programm benoetigt mindestens eine EGA-Karte mit 256k RAM!');
      2 : writeln('Dieses Programm benoetigt mindestens 256k Video-RAM!');
      3 : writeln('Dieses Programm benoetigt einen EGA- oder VGA-Monitor!');
      4 : writeln('Fehler beim Initialisieren des internen EGAVGA-Graphiktreibers!');
      5 : writeln('Fehler beim Einbinden oder Initialisieren des externen EGAVGA-Graphiktreibers!');
      6 : writeln('Fehler beim Initialisieren des EGA/VGA-Grafikpaket!');
      7 : writeln('Fehler beim Einbinden des externen ',bginame,'-Graphiktreibers!');
      8 : writeln('Fehler beim Initialisieren des externen ',bginame,'-Graphiktreibers!')
    end;
    halt(1)
  end;
  regs.AH:=2;
  regs.BH:=0;
  regs.DX:=0;            {DH=Zeile-1 DL=Spalte-1}
  intr(16,regs);         {BIOS: Cursor bei 1:1 positionieren}
  regs.AX:=$1130;
  regs.BH:=0;            {EGA-BIOS: Infos ber Zeichengenerator holen}
  intr(16,regs);
  offset:=succ(regs.CX); {Zeichenpixelhhe+1}
  uz:=succ(regs.DL);     {Textzeilenzahl}
  wincount:=0;
  winxy[0,1]:=0;
  winxy[0,2]:=0;
  winxy[0,3]:=getmaxx;
  winxy[0,4]:=getmaxy;
end;

procedure HLine3(x1,x2,y:integer;setatr:boolean);external; {$L Video }

procedure ClearBlock3(y1,y2:integer);external;

procedure delline(x1,y1,x2:integer);
begin
  hline3(x1,x2,y1,false)
end;

procedure fastline(x1,y1,x2:integer);
begin
  hline3(x1,x2,y1,true)
end;

procedure fastblock(y1,y2:word);
begin
  ClearBlock3(y1,y2)
end;

procedure delchar(x1,y1:word);
var c, i : word;
begin
  c:=getcolor;
  setcolor(getbkcolor);
  x1:=x1-8;
  for i:=y1 to y1+9 do hline3(x1,x1+7,i,true);   { fastline(x1,i,x1+7); }
  setcolor(c)
end;


end.
