{***************************************************
 *                                                 *
 *    SAT-Master Hilfsprogramm MAKEDAT.PAS v1.0    *
 *                                                 *
 ***************************************************}
{$A+,L-,R-,S-,I-,F-,O-,N+,E+,L-,V+,B-,M 16384 0 655360}
program makedat;
const version   : string[4] = '1.0';
      copyright : string[10] = 'DB1HZ 1991';
      teststr   : array[1..14] of string =
                  ('SATELLITE: ',
                   'EPOCH TIME: ',
                   'INCLINATION: ',
                   'RA OF NODE: ',
                   'ECCENTRICITY: ',
                   'ARG OF PERIGEE: ',
                   'MEAN ANOMALY: ',
                   'MEAN MOTION: ',
                   'DECAY RATE: ',
                   'EPOCH REV: ',
                   'ALON: ',
                   'ALAT: ',
                   'AA: ',
                   'DA: ');
var  f1     : text;
     g      : string[12];
     ok     : boolean;
     datstr : array[1..14] of string;

function extract(z:string):string;
const  okstr1 : string[11] = '-0123456789';
       okstr2 : string[14] = '+-0123456789.E';
var    e     : string;
begin
  while (pos(z[1],okstr1)=0) and (z<>'') do delete(z,1,1);
  e:='';
  while (pos(z[1],okstr2)>0) and (z<>'') do begin
    e:=e+z[1];
    delete(z,1,1)
  end;
  extract:=e
end;

function test(z:string):byte;
var i, j : byte;
begin
  i:=1;
  j:=15;
  repeat
    if pos(teststr[i],z)>0 then j:=i;
    inc(i);
  until j<=i;
  test:=j
end;

procedure fclear(s:string);
var f : text;
    i, n : byte;
    dummy : string;
begin
  assign(f,s);
  reset(f);
  if ioresult=0 then begin
    readln(f,datstr[1]);
    for i:=2 to 10 do readln(f,dummy);
    for i:=11 to 14 do begin
      if not eof(f) then begin
        readln(f,datstr[i]);
        n:=test(datstr[i]);
        if (n<>13) and (n<>14) then datstr[i]:=''
      end
    end;
    if (datstr[11]='') or (datstr[12]='') then begin
      if (datstr[13]<>'') and (datstr[14]<>'') then begin
        if test(datstr[13])=13 then begin
          datstr[11]:=datstr[13];
          datstr[12]:=datstr[14]
        end else begin
          datstr[11]:=datstr[14];
          datstr[12]:=datstr[13]
        end;
        datstr[13]:='';
        datstr[14]:=''
      end else begin
        datstr[11]:='';
        datstr[12]:=''
      end
    end;
    close(f);
    erase(f)
  end else begin
    close(f);
    for i:=11 to 14 do datstr[i]:=''
  end;
  i:=ioresult
end;

function kplstr(i:byte; s:string):string;
var s2 : string;
begin
  s2:=teststr[i];
  while length(s2)<18 do s2:=s2+' ';
  kplstr:=s2+s
end;

procedure save(h:string);
var f : text;
    i : byte;
begin
  fclear(h);
  assign(f,h);
  rewrite(f);
  if ioresult=0 then begin
    for i:=3 to 10 do if datstr[i]='' then datstr[i]:=kplstr(i,'0');
    for i:=1 to 14 do if datstr[i]<>'' then begin
      writeln(datstr[i]);
      writeln(f,datstr[i])
    end;
    writeln('File ',h,' erzeugt')
  end else writeln('File ',h,' lt sich nicht ffnen');
  close(f);
  h:='';
  for i:=1 to 14 do datstr[i]:=''
end;

procedure convert;
var h, s : string;
    i : byte;
begin
  h:='';
  for i:=1 to 14 do datstr[i]:='';
  repeat
    readln(f1,s);
    for i:=1 to length(s) do s[i]:=upcase(s[i]);
    i:=test(s);
    if (i>0) and (i<15) then begin
      if i>1 then s:=extract(s) else begin
        if h<>'' then save(h);
        delete(s,1,11);
        while pos(' ',s)>0 do delete(s,pos(' ',s),1);
        h:=s;
        while pos('.',h)>0 do delete(h,pos('.',h),1);
        while pos('/',h)>0 do h[pos('/',h)]:='-';
        h:=copy(h,1,8)+'.SAT'
      end;
      datstr[i]:=kplstr(i,s)
    end;
  until eof(f1);
  if h<>'' then save(h)
end;

begin
  if paramcount=0 then begin
    writeln('SAT-Master MAKEDAT v',version,'   (C) ',copyright);
    writeln;
    writeln('Dieses Programm wandelt die in Packet-Radio verbreiteten Bahndaten');
    writeln('in die Datenstze von SAT-Master um. Bestehende Datenstze werden');
    writeln('gendert.');
    writeln;
    writeln('   Syntax:   makedat <Quelldatei>');
    writeln;
    writeln('Der Name der Quelldatei mu vollstndig und mit Erweiterung angegeben werden.');
    writeln;
    writeln('Dieses Programm wurde von DB1HZ geschrieben. Alle Rechte vorbehalten.');
    writeln('Die kommerzielle Nutzung dieses Programms ist untersagt!');
    writeln
  end else begin
    g:=paramstr(1);
    assign(f1,g);
    reset(f1);
    if ioresult=0 then convert else writeln('File ',g,' nicht gefunden');
    close(f1)
  end
end.
