{***********************************************
 *                                             *
 *   SAT-Master v1.81  Mathe-Unit MATHE.PAS    *
 *                                             *
 ***********************************************

Ich danke besonders Oliver P. fuer seine Assemblerroutinen
fuer 387er, 486er und IIT-2C87

 ************************************ }

{$A+,L-,R-,S-,I+,F-,O-,N+,E+,L-,V+,B-,M 16384 0 655360}
Unit Mathe;
interface

var   tan    : function(wert:extended):extended;
      arcsin : function(wert:extended):extended;
      arccos : function(wert:extended):extended;

function hoch(wert,expon:extended):extended;

implementation

const PiHalbe : extended = 1.570796326794945; { fehlen noch 4 Stellen }

function iit:boolean;            { nach c't }
var  sw87, cw87 : word;
begin
  if test8087=2 then begin
    inline(
      $D9/$7E/<cw87/         { FSTCW cw87[BP]         ; store control word }
      $DB/$E3/               { FINIT                  ; }
      $DB/$E8/               { FSBP0                  ; set bank 0 }
      $D9/$EE/               { FLDZ                   ; load zero }
      $DB/$E3/               { FINIT                  ; }
      $DB/$EB/               { FSBP1                  ; set bank 1 }
      $D9/$E8/               { FLD1                   ; load 1 }
      $DB/$E8/               { FSBP0                  ; set bank 0 }
      $D9/$E4/               { FTST                   ; test zero }
      $DD/$7E/<sw87/         { FSTW sw87[BP]          ; store status word }
      $DB/$E3/               { FINIT                  ; }
      $D9/$6E/<cw87          { FLDCW cw87[BP]         ; load control word }
    );
    iit:=(sw87 and $4100)=$4000
  end else iit:=false
end;

function hoch(wert,expon:extended):extended;
begin
  hoch:=exp(ln(wert)*expon)
end;

{$F+}
Function Tangens387(wert:extended):extended;
begin
  inline($DB/$6E/<Wert/     { fld wert }
         $D9/$F2/           { fptan    }
         $DE/$F9/           { fdivp    }
         $8B/$E5/           { mov sp,bp}
         $5D/               { pop bp   }
         $CA/$0A/$00)       { retf 0A  }
end;

Function ArcSinus387(wert:extended):extended;
begin
  inline($DB/$6E/<Wert/     { fld wert  }
         $D9/$E8/           { fld1      }
         $D9/$C1/           { fld st(0) }
         $D8/$C8/           { fmul st(0)}
         $DE/$E9/           { fsubp     }
         $D9/$FA/           { fsqrt     }
         $D9/$F3/           { fpatan    }
         $8B/$E5/           { mov sp,bp }
         $5D/               { pop bp    }
         $CA/$0A/$00)       { retf 0A   }
end;

Function ArcCosinus387(wert:extended):extended;
begin
  inline($DB/$2E/pihalbe/    { fld pihalbe }
         $DB/$6E/<Wert/      { fld wert    }
         $D9/$E8/            { fld1        }
         $D9/$C1/            { fld st(1)   }
         $D8/$C8/            { fmul st(0)  }
         $DE/$E9/            { fsubp       }
         $D9/$FA/            { fsqrt       }
         $D9/$F3/            { fpatan      }
         $DE/$E9/            { fsubp       }
         $8B/$E5/            { mov sp,bp   }
         $5D/                { pop bp      }
         $CA/$0A/$00)        { retf 0A     }
end;

function tan87(wert:extended):extended;
begin
  tan87:=sin(wert)/(cos(wert))   { kann auch optimiert werden }
end;

function arcsin87(wert:extended):extended;
begin
  arcsin87:=arctan(wert/(sqrt(1-wert*wert)))
end;

function arccos87(wert:extended):extended;
begin
  arccos87 := 1.570796326794945 - arctan(wert/(sqrt(1-sqr(wert))))
end;

begin
  if iit then test8087:=3;
  if test8087>2 then begin
    tan    := tangens387;
    arcsin := arcsinus387;
    arccos := arccosinus387
  end else begin
    tan    := tan87;
    arcsin := arcsin87;
    arccos := arccos87
  end
end.
