{***************************************************
 *                                                 *
 *    SAT-Master Hilfsprogramm NASADAT.PAS v1.3    *
 *                                                 *
 ***************************************************}
{$A+,L-,R-,S-,I-,F-,O-,N+,E+,L-,V+,B-,M 16384 0 655360}
program nasadat;
const version : string[4] ='1.3';
      copyright : string[10] = 'DB1HZ 1991';
      teststr : array[1..14] of string =
                ('SATELLITE:',
                 'EPOCH TIME:',
                 'INCLINATION:',
                 'RA OF NODE:',
                 'ECCENTRICITY:',
                 'ARG OF PERIGEE:',
                 'MEAN ANOMALY:',
                 'MEAN MOTION:',
                 'DECAY RATE:',
                 'EPOCH REV:',
                 'ALON:',
                 'ALAT:',
                 'AA:',
                 'DA:');
var  f1     : text;
     g      : string[12];
     ok     : boolean;
     datstr : array[1..14] of string;

function fillnull(z:string):string; {von DL3MDT; fllt Lcken in z mit 0 auf}
var i : byte;
begin
   i := 1;
   while i <= length(z) do
     begin
       if z[i] = ' ' then z[i] := '0';  { wenn LEERZEICHEN dann 0 einfuegen }
       inc ( i );
     end;
   fillnull := z;
end;

function pur(z:string):string;
begin
  while pos(' ',z)>0 do delete(z,pos(' ',z),1);
  pur:=z
end;

function test(z:string):byte;
var i, j : byte;
begin
  i:=1;
  j:=15;
  repeat
    if pos(teststr[i],z)>0 then j:=i;
    inc(i);
  until j<=i;
  test:=j
end;

function name(z:string):string;
begin
  while (pos(' ',z)=1) and (length(z)>0) do delete(z,pos(' ',z),1);
  while (z[length(z)]=' ') and (length(z)>0) do delete(z,length(z),1);
  while (pos('.',z)>0) and (length(z)>0) do delete(z,pos('.',z),1);
  while pos('/',z)>0 do z[pos('/',z)]:='-';
  while length(z)>8 do delete(z,4,1);
  name:=pur(z)+'.SAT'
end;

function kplstr(z:string):string;
begin
  while length(z)<18 do z:=z+' ';
  kplstr:=z
end;

procedure fclear(s:string);
var f : text;
    i, n : byte;
    dummy : string;
begin
  assign(f,s);
  reset(f);
  if ioresult=0 then begin
    readln(f,datstr[1]);
    for i:=2 to 10 do readln(f,dummy);
    for i:=11 to 14 do begin
      if not eof(f) then begin
        readln(f,datstr[i]);
        n:=test(datstr[i]);
        if (n<>13) and (n<>14) then datstr[i]:=''
      end
    end;
    if (datstr[11]='') or (datstr[12]='') then begin
      if (datstr[13]<>'') and (datstr[14]<>'') then begin
        if test(datstr[13])=13 then begin
          datstr[11]:=datstr[13];
          datstr[12]:=datstr[14]
        end else begin
          datstr[11]:=datstr[14];
          datstr[12]:=datstr[13]
        end;
        datstr[13]:='';
        datstr[14]:=''
      end else begin
        datstr[11]:='';
        datstr[12]:=''
      end
    end;
    close(f);
    erase(f)
  end else begin
    close(f);
    for i:=11 to 14 do datstr[i]:=''
  end;
  i:=ioresult
end;

procedure save(h:string);
var f : text;
    i : byte;
begin
  writeln;
  fclear(h);
  assign(f,h);
  rewrite(f);
  if ioresult=0 then begin
    for i:=3 to 10 do if datstr[i]='' then datstr[i]:=kplstr(teststr[i])+'0';
    for i:=1 to 14 do if datstr[i]<>'' then writeln(f,datstr[i]);
    writeln('File ',h,' erzeugt')
  end else writeln('File ',h,' lt sich nicht ffnen');
  close(f);
  h:='';
  for i:=1 to 14 do datstr[i]:=''
end;

procedure convert;
var s, t, u : string;
    i : byte;

  procedure c2;
  var i : byte;
  begin
    if (t[1]='1') and (t[2]=' ') and (u[1]='2') and (u[2]=' ')
     and not (t[3]='A') then begin
      datstr[1]:=kplstr(teststr[1])+pur(s);
      datstr[2]:=kplstr(teststr[2])+pur(fillnull(copy(t,19,14)));
      datstr[3]:=kplstr(teststr[3])+pur(copy(u,9,8));
      datstr[4]:=kplstr(teststr[4])+pur(copy(u,18,8));
      datstr[5]:=kplstr(teststr[5])+'0.'+pur(copy(u,27,7));
      datstr[6]:=kplstr(teststr[6])+pur(copy(u,35,8));
      datstr[7]:=kplstr(teststr[7])+pur(copy(u,44,8));
      datstr[8]:=kplstr(teststr[8])+pur(copy(u,53,11));
      if pur(copy(t,34,1))='-' THEN
        datstr[9]:=kplstr(teststr[9])+'-0'+pur(copy(t,35,10))
      ELSE
        datstr[9]:=kplstr(teststr[9])+'0'+pur(copy(t,35,10));
      datstr[10]:=kplstr(teststr[10])+pur(copy(u,64,5));
      for i:=1 to 14 do if datstr[i]<>'' then writeln(datstr[i]);
      s:=name(s);
      save(s)
    end
  end;

begin
  for i:=1 to 10 do datstr[i]:=kplstr(teststr[i]);
  for i:=11 to 14 do datstr[i]:='';
  if not eof(f1) then readln(f1,s);
  if not eof(f1) then readln(f1,t);
  if not eof(f1) then readln(f1,u);
  repeat
    c2;
    if not eof(f1) then begin
      s:=t;
      t:=u;
      readln(f1,u)
    end;
  until eof(f1)
end;

begin
  if paramcount=0 then begin
    writeln('SAT-Master NASADAT v',version,'   (C) ',copyright);
    writeln;
    writeln('Dieses Programm wandelt die in Packet-Radio verbreiteten Bahndaten');
    writeln('im NASA-Format in die Datenstze von SAT-Master um. Bestehende Datenstze');
    writeln('werden gendert.');
    writeln;
    writeln('   Syntax:   nasadat <Quelldatei>');
    writeln;
    writeln('Der Name der Quelldatei mu vollstndig und mit Erweiterung angegeben werden.');
    writeln;
    writeln('Dieses Programm wurde von DB1HZ geschrieben. Alle Rechte vorbehalten.');
    writeln('Die kommerzielle Nutzung dieses Programms ist untersagt!');
    writeln('Ich danke DL3MDT fuer seine Mitwirkung.');
    writeln
  end else begin
    g:=paramstr(1);
    assign(f1,g);
    reset(f1);
    if ioresult=0 then convert else writeln('File ',g,' nicht gefunden');
    close(f1)
  end
end.
