{***********************************************
 *                                             *
 *    SAT-Master v1.75  Include-File SAT.INC   *
 *                                             *
 ***********************************************

procedure systime;
procedure loaddummy;
procedure konvert(alon, alat:extended; a:byte);
procedure loaddata;
procedure zeileoben;
procedure monitor;
procedure sichtausgabe(sl, sb, sr:extended);
procedure sichtein;
procedure sichtaus;
procedure mond;
function doy:extended;
function time:extended;
function amsattime(a:byte):extended;
procedure berech(a:byte);
procedure solephemeriden(dtime:extended);

********************************************}

procedure systime;
begin
  getdate(jahr,monat,tag,wtag);
  gettime(stunde,minute,sekunde,sek100);
  rechnerzeit:=stunde/24+minute/1440+sekunde/86400+sek100/8640000
end;

procedure loaddummy;
begin                          { Dummy Bahndaten AO13 }
  sat          := 1;
  satnam[sat]  := 'Amsat Oscar 13';
  satet[sat]   := 91053.11379;        {22.2.1991}
  satincl[sat] := 56.83;
  satraan[sat] := 109.09;
  satecc[sat]  := 0.7128;
  satargp[sat] := 247.86;
  satma[sat]   := 26.43;
  satmm[sat]   := 2.09704;
  satemm[sat]  := -0.0000013;
  satuml[sat]  := 2061;
  sataa[sat]   := 157.869;
  satda[sat]   := 52.896
end;

procedure konvert(alon, alat:extended; a:byte);
{*******************************************************
wandelt aLON und aLAT fuer Satellit Nr. a in aA und dA um.
Algorithmus nach DL1TV - siehe AMSAT-DL 2/90 S.13
 *******************************************************}
var dabm, i, si, ci, w1, w2, da, aa : extended;
begin
  i:=satincl[a]*bm;
  w2:=450-satargp[a]-alon;
  da:=arcsin(cos(i)*sin(alat*bm)+sin(i)*cos(alat*bm)*cos(w2*bm));
  w1:=arccos((sin(alat*bm)-cos(i)*sin(da))/(sin(i)*cos(da)))/bm;
  if sin(w2*bm)<0 then w1:=360-w1;
  sataA[a]:=w1+satraan[a]-90;
  satdA[a]:=da/bm
end;

procedure loaddata;
{*******************************************************
-laedt die Config-Datei SAT.DAT ein und wertet die einzelnen
 Angaben gleich aus.
-laedt die einzelnen Bahndaten ein und schreibt die Werte in das Feld.
 *******************************************************}
var  di : searchrec;
     i  : integer;
     f  : text;
     d, s, s1, s2  : string;
     j             : boolean;
     alon, alat, w : extended;
     k  : array[1..9] of boolean;

  function del(a:string):string;
  { *****
  reduziert einen String bis zum ersten nicht-Leerzeichen nach dem
  Doppelpunkt und schneidet alle Leerzeichen am Ende weg,
  reduziert also die Zeile auf den wesentlichen Inhalt.
    ***** }
  begin
    if pos(':',a)>0 then delete(a,1,succ(pos(':',a)));
    while ((pos(' ',a)=1) or (pos(' ',a)=length(a))) and (length(a)>0)
     do delete(a,pos(' ',a),1);
    del:=a
  end;

  function rd:extended;
  { *****
  list eine Zeile aus der Datei f ein und gibt die extrahierte Zahl zurueck
    ***** }
  var  w : real;
       t : string;
  begin
    if not eof(f) and not j then begin
      readln(f,t);
      t:=del(t);
      val(t,w,i);
      if i<>0 then j:=true else rd:=w
    end
  end;

begin
  amsat:=false;
  for i:=1 to 9 do k[i]:=false;
  {$I-}
  assign(f,'SAT.DAT');
  reset(f);
  if ioresult=0 then begin
    while not eof(f) do begin
      readln(f,s);
      if pos(':',s)>0 then begin
        s2:=copy(s,1,pred(pos(':',s)));
        d:=del(s);
        if s2='BGI' then begin
          while not (d[1]=' ') and (length(d)>0) do begin
            if (length(bginame)<8) and (d[1]<>'.') then bginame:=bginame+d[1];
            delete(d,1,1)
          end;
          s1:=del(d);
          if length(s1)>0 then begin
            val(s1,w,i);
            bgimodus:=round(w)
          end
        end else val(d,w,i);
        if s2='LAENGE' then begin
          laenge:=w;
          k[1]:=true
        end;
        if s2='BREITE' then begin
          breite:=w;
          k[2]:=true
        end;
        if s2='ZEITZONE' then begin
          zeitzone:=round(w);
          k[3]:=true
        end;
        if s2='RECHTS' then begin
          rotor[1]:=round(w) and 255;
          k[4]:=true
        end;
        if s2='LINKS' then begin
          rotor[2]:=round(w) and 255;
          k[5]:=true
        end;
        if s2='OBEN' then begin
          rotor[3]:=round(w) and 255;
          k[6]:=true
        end;
        if s2='UNTEN' then begin
          rotor[4]:=round(w) and 255;
          k[7]:=true
        end;
        if s2='ANSCHLAG' then begin
          anschlag:=round(w);
          k[8]:=true
        end;
        if s2='LPT' then begin
          lpt:=round(w-1) and 3;
          k[9]:=true
        end
      end else begin
        while (pos(' ',s)>0) and (length(s)>0) do delete(s,pos(' ',s),1);
        if s='AMSAT' then amsat:=true
      end
    end
  end;
  if not k[1] then laenge:=10;
  if not k[2] then breite:=53.5;
  if not k[3] then zeitzone:=0;
  if amsat then begin
    if not k[4] then rotor[1]:=255;
    if not k[5] then rotor[2]:=0;
    if not k[6] then rotor[3]:=127;
    if not k[7] then rotor[4]:=0;
    if not k[8] then anschlag:=180;     {default: Sued}
    if not k[9] then lpt:=1             {default: LPT2}
  end;
  close(f);
  {$I+}
  i:=ioresult;
  sat:=0;
  i:=0;
  findfirst('*.SAT',i,di);
  while (doserror=0) and (sat<maxsat) do begin
    d:=di.name;
    assign(f,d);
    {$I-}
    reset(f);
    if ioresult=0 then begin
      j:=false;
      inc(sat);
      if not eof(f) then readln(f,s) else j:=true;
      s:=del(s);
      satnam[sat]:=s;
      if satnam[sat]='' then satnam[sat]:=chr(64+sat)+'?';
      satet[sat]:=rd;
      if (satet[sat]<0) or (satet[sat]>=100000) then j:=true;
      satincl[sat]:=rd;
      if (satincl[sat]<0) or (satincl[sat]>180) then j:=true;
      satraan[sat]:=rd;
      if (satraan[sat]<0) or (satraan[sat]>360) then j:=true;
      satecc[sat]:=rd;
      if (satecc[sat]<0) or (satecc[sat]>=1) then j:=true;
      satargp[sat]:=rd;
      if (satargp[sat]<0) or (satargp[sat]>360) then j:=true;
      satma[sat]:=rd;
      if (satma[sat]<0) or (satma[sat]>360) then j:=true;
      satmm[sat]:=rd;
      if (satmm[sat]<=0) or (satmm[sat]>50) then j:=true;
      satemm[sat]:=rd;
      if satemm[sat]>1 then satemm[sat]:=0;
      if eof(f) then j:=true;
      satuml[sat]:=trunc(rd);
      if satuml[sat]<0 then j:=true;
      alon:=0;
      alat:=0;
      sataa[sat]:=0;
      satda[sat]:=0;
      while not eof(f) and not j do begin
        readln(f,s1);
        s2:=del(s1);
        val(s2,w,i);
        if i=0 then begin
          s1:=copy(s1,1,3);
          if s1='ALO' then alon:=w;
          if s1='ALA' then alat:=w;
          if s1='AA:' then sataa[sat]:=w;
          if s1='DA:' then satda[sat]:=w;
        end else j:=true
      end;
      if not j then begin
        if (alon<-180) or (alon>360) or (alat<-90) or (alat>180) then begin
          alon:=0;
          alat:=0
        end;
        if (sataa[sat]<-180) or (sataa[sat]>360) or (satda[sat]<-90) or
         (satda[sat]>180) then begin
          sataa[sat]:=0;
          satda[sat]:=0
        end;
        if (sataa[sat]=0) and (satda[sat]=0) and ((alon<>0) or (alat<>0))
         then konvert(alon, alat, sat)
      end else dec(sat)
    end;
    close(f);
    {$I+}
    findnext(di)
  end;
end;

procedure zeileoben;
const wt : array[0..6] of string = ('Sonntag','Montag','Dienstag','Mittwoch',
                                    'Donnerstag','Freitag','Sonnabend');
var   i : word;
begin
  setcolor(12);
  if minute<>mminute then begin
    str(stunde:2,txt);
    textzeile:=txt+':';
    if minute<10 then begin
      textzeile:=textzeile+'0';
      str(minute:1,txt);
    end else str(minute:2,txt);
    textzeile:=textzeile+txt;
    grwritexy(2,1,textzeile,14);
    mminute:=minute
  end;
  if tag<>mtag then begin
    str(tag,textzeile);
    textzeile:=wt[wtag]+' '+textzeile;
    str(monat,txt);
    textzeile:=textzeile+'.'+txt;
    str(jahr,txt);
    textzeile:=textzeile+'.'+txt;
    for i:=length(textzeile) to 21 do textzeile:=textzeile+' ';
    grwritexy(12,1,textzeile,14);
    mtag:=tag
  end
end;

procedure monitor;
const ekls   : string[7] = 'Eklipse';
var   i      : word;
      j      : integer;
      sl, sb : integer;
      d      : extended;
      s      : string[20];
begin
  sl:=round(sspl);
  sb:=round(sspb);
  if (squint<>msquint) and (squint<181) then begin
    if (ekl xor mekl) or (mtag=0) then begin
      if ekl then txt:=ekls else begin
        str(round(100*ill),s);
        txt:='  Ill: '+s+'%'
      end;
      mekl:=ekl
    end else begin
      str(round(100*ill),s);
      txt:='  Ill: '+s+'%'
    end;
    str(squint,s);
    txt:=txt+'  Sq: '+s+chr(248);
    grwritexy(81-length(txt),1,txt,14);
    msquint:=squint
  end else begin
    if (ekl xor mekl) or (mtag=0)  then begin
      if ekl then begin
        txt:='   '+ekls;
        grwritexy(81-length(txt),1,txt,14)
      end else begin
        txt:=copyright;
        grwritexy(81-length(txt),1,txt,15)
      end;
      mekl:=ekl
    end
  end;
  zeileoben;
  if sb<>msspb then begin
    if sb<0 then begin
      str(-sb,txt);
      txt:=txt+chr(248)+'S'
    end else begin
      str(sb,txt);
      txt:=txt+chr(248)+'N'
    end;
    if length(txt)<4 then txt:=' '+txt;
    grwritexy(2,uz,txt,14);
    msspb:=sb
  end;
  if sl<>msspl then begin
    if sl<0 then begin
      str(-sl,txt);
      txt:=txt+chr(248)+'W'
    end else begin
      str(sl,txt);
      txt:=txt+chr(248)+'O'
    end;
    txt:=txt+' ';
    grwritexy(7,uz,txt,14);
    msspl:=sl
  end;
  if sspr<>msspr then begin
    str(sspr,txt);
    txt:=txt+' km ';
    grwritexy(13,uz,txt,14);
    msspr:=sspr
  end;
  if wahl=255 then begin
    txt:='         ';
    grwritexy(25,uz,txt,14)
  end else begin
    j:=round(int(anomalie));
    if j<>manomalie then begin
      str(j,txt);
      if j<100 then txt:=' '+txt;
      if j<10 then txt:=' '+txt;
      grwritexy(29,uz,txt,14);
      manomalie:=j
    end
  end;
  if orbit<>morbit then begin
    str(orbit,txt);
    grwritexy(33,uz,txt,14);
    morbit:=orbit
  end;
  j:=round(azimut);
  if j<>mazimut then begin
    str(j,txt);
    if azimut<100 then txt:=' '+txt;
    if azimut<10 then txt:=' '+txt;
    grwritexy(50,uz,txt,14);
    mazimut:=j;
    ant(azimut,elevation)            {Antenne steuern}
  end;
  j:=round(elevation);
  if j<>melevation then begin
    str(j,txt);
    textzeile:=txt+' ';
    grwritexy(54,uz,textzeile,14);
    melevation:=j;
    ant(azimut,elevation)            {Antenne steuern}
  end;
  if entfernung<>mentfernung then begin
    if entfernung>999999 then begin
      d:=entfernung/ae;
      str(d:1:4,txt);
      textzeile:=txt+' AE'
    end else begin
      str(entfernung,txt);
      textzeile:=txt+' km'
    end;
    if length(textzeile)<9 then textzeile:=textzeile+' ';
    grwritexy(71,uz,textzeile,14);
    mentfernung:=entfernung
  end
end;

procedure sichtausgabe(sl, sb, sr:extended);
{*********
Eingaben: SubSatellitenPunkt (sl,sb,sr)
Ausgaben: Sichtbereich des Satelliten auf der Weltkarte als heller Bereich
 *********}
var s1, c1, s2, c2, s3, cc, xl, xx : extended;
    i, j, eb, x1, x2, yy : integer;

begin
  eb:=round(y-y/180*(90+sspb))+offset;
  xl:=180+sl;
  xx:=x/360;
  s1:=sqrt(sr*sr-1);             {Tangentenlaenge in Erdradien}
  s1:=arcsin(s1/sr);             {Sichtwinkel}
  s2:=bm*(90-sb);                {Nordpolwinkel=90 Grad-Subsatpunktsbreite}
  if s1>s2 then yy:=offset else
    yy:=offset+round((s2-s1)*y/pi);   {Sichtbeginn}
  bend:=y+offset;
  banf:=yy;
  c1:=cos(s1);
  s1:=sin(s1);
  c2:=cos(s2);
  s2:=sin(s2);
  i:=banf-2;
  if offset>i then i:=offset;
  fastblock(i,banf);
  repeat
    s3:=pi*(2-(offset-yy)/y);
    cc:=(c1-c2*cos(s3))/(s2*sin(s3)+1E-15);   {Seitencosinussatz}
    if cc<1 then begin
      if cc>-1 then begin
        cc:=arccos(cc)/bm;
        x1:=round(xx*(xl-cc));     {Laengengradschnittpunkt 1}
        x2:=round(xx*(xl+cc));     {Laengengradschnittpunkt 2}
        if x1<0 then begin
          if x2<0 then begin
            delline(0,yy,pred(x1+x));
            fastline(x1+x,yy,x2+x);
            delline(succ(x2+x),yy,x);
          end else begin
            fastline(0,yy,x2);
            delline(succ(x2),yy,pred(x+x1));
            fastline(x+x1,yy,x)
          end
        end else begin
          if x2<0 then begin
            fastline(0,yy,x1);
            delline(succ(x1),yy,pred(x+x2));
            fastline(x+x2,yy,x)
          end else begin
            if x1>x-1 then begin
              if x2>x-1 then begin
                delline(0,yy,pred(x1-x));
                fastline(x1-x,yy,x2-x);
                delline(succ(x2-x),yy,x)
              end else begin
                fastline(0,yy,x1-x);
                delline(succ(x1-x),yy,pred(x2));
                fastline(x2,yy,x)
              end
            end else begin
              if x2>x-1 then begin
                fastline(0,yy,x2-x);
                delline(succ(x2-x),yy,pred(x1));
                fastline(x1,yy,x)
              end else begin
                delline(0,yy,pred(x1));
                fastline(x1,yy,x2);
                delline(succ(x2),yy,x)
              end
            end
          end
        end
      end else fastline(0,yy,x)
    end else if yy>eb then begin
      i:=yy;
      bend:=pred(yy);
      yy:=y+offset;
      j:=i+2;
      if j>yy then j:=yy;
      fastblock(i,j)
    end;
    inc(yy);
    s3:=pi*(2-(offset-yy)/y);
  until (yy>y+offset)
end;

procedure sichtein;
var i, vx1, vx2, vy1, vy2 : integer;
begin
  setcolor(8);
  vx1:=ssph-3;
  if vx1<0 then vx1:=0;
  vy1:=sspv-3;
  if vy1<0 then vy1:=0;
  vx2:=ssph+3;
  if vx2>x then vx2:=x;
  vy2:=sspv+3;
  if vy2>y+offset then vy2:=y+offset;
  for i:=vy1 to vy2 do fastline(vx1,i,vx2);
  getimage(vx1,vy1,vx2,vy2,memssp^);
  sichtausgabe(sspl,sspb,sspe);
  sil:=sspl;
  sib:=sspb;
  sir:=sspe
end;

procedure sichtaus;
{***************
Loeschen des SSP-Kreuz durch zurueckkopieren des Kartenteils
 ***************}
var vx1, vx2, vy1, vy2 : integer;
begin
  vx1:=sspi-3;
  if vx1<0 then vx1:=0;
  vy1:=sspj-3;
  if vy1<0 then vy1:=0;
  putimage(vx1,vy1,memssp^,0)
end;

procedure mond;
{**************************************
Die astronomisch exaktere Berechnung der Mondposition mit
einer Abweichung kleiner als 1 Grad fuer EME-Anwendungen.
Die normale Naeherung mittels Keplerdaten ist dafuer nicht genau genug.
Die Algorithmen sind der CQ-DL entnommen und von BASIC in Pascal umgesetzt.
 **************************************}
const mr : extended = 1738.2;
var   ta,mo,ja : word;
      am,at,ba,bi,bn,bo,db,dc,de,dj,dk,dn,ds,dt,em,et,hc,hk,ho,
      hp,hs,kl,la,ma,me,mk,ml,ne,ot,ra,rc,rd,rh,rma,rk,sa,sc,sd,sg,
      sk,sr,sw,sz,te,tq,ts,zt : extended;
      s : string;
begin
  ja:=jahr-1900;
  mo:=monat;
  ta:=tag;
  zt:=24*frac(rechnerzeit)+zeitzone;
  ts:=ta+zt/24;
     {jul.Datum}
  db:=int((ja-1)/4)+int(30.6*mo+0.53/(sqr(mo-1.55))-32.3)+ts-0.5;
  if (frac(ja/4)<0.1) and (mo>2) then db:=db+1;
  dt:=db;
  dn:=365*ja+db;
  te:=dn/36525;
  tq:=te*te;
     {Ortszeit}
  ot:=zt+laenge/15;
  if ot>=24 then ot:=ot-24;
  sg:=6.645854+2400.0513*te+0.00002581*tq;
  sr:=sg+zt+laenge/15;
  sz:=sr-24*int(sr/24);
  ne:=23.452294-0.0130125*te;
  et:=1-0.002495*te-0.00000752*tq;
  ml:=270.4342+481267.88*te-0.001*tq;
  sa:=358.4758+35999.05*te-0.00015*tq;
  ma:=296.1046+477198.85*te+0.0092*tq;
  me:=350.7375+445267.11*te-0.0014*tq;
  mk:=11.2509+483202.02*te-0.00321*tq;
  kl:=ml+6.28875*sin(ma*bm)+1.274018*sin((2*me-ma)*bm)+0.65831*sin(2*me*bm)
      +0.213616*sin(2*ma*bm)-(0.185596*sin(sa*bm))*et-0.114336*sin(2*mk*bm)
      +0.058793*sin(2*(me-ma)*bm)+(0.057212*sin((2*me-sa-ma)*bm))*et+0.05332*sin((2*me+ma)*bm)
      +(0.04587*sin((2*me-sa)*bm))*et+(0.04102*sin((ma-sa)*bm))*et-0.034718*sin(me*bm)
      -(0.030465*sin((sa+ma)*bm))*et+0.015326*sin(2*(me-mk)*bm);
  la:=360*frac(kl/360);
  ba:=5.128189*sin(mk*bm)+0.280606*sin((ma+mk)*bm)+0.277693*sin((ma-mk)*bm)
      +0.173238*sin((2*me-mk)*bm)+0.55413*sin((2*me+mk-ma)*bm)+0.046272*sin((2*me-mk-ma)*bm)
      +0.032573*sin((2*me+mk)*bm)+0.017198*sin((2*ma+mk)*bm);
  ra:=arctan((sin(la*bm)*cos(ne*bm)-tan(ba*bm)*sin(ne*bm))/cos(la*bm))/bm;
  if cos(la*bm)<0 then ra:=ra+180;
  while ra<0 do ra:=ra+360;
  ds:=sin(ba*bm)*cos(ne*bm)+cos(ba*bm)*sin(ne*bm)*sin(la*bm);
  de:=arcsin(ds)/bm;
  sw:=180+sz*15-ra;
  if sw<0 then sw:=sw+360;
  if sw>=360 then sw:=sw-360;
  hs:=sin(breite*bm)*sin(de*bm)+cos(breite*bm)*cos(de*bm)*cos((180-sw)*bm);
  ho:=arcsin(hs)/bm;
  hp:=0.950724+0.051818*cos(ma*bm)+0.00953*cos((2*me-ma)*bm)+0.007843*cos((2*me-ma)*bm)
      +0.007843*cos(2*me*bm)+0.002824*cos(2*ma*bm);
  sspe:=1/sin(hp*bm);
  em:=er*sspe;
  bn:=sqrt(er*er+em*em-2*er*em*sin(ho*bm));
  bo:=bn-mr;
  bi:=round(bo*10)/10;
  dc:=(em*sin(de*bm)-er*sin(breite*bm))/bn;
  dk:=arcsin(dc)/bm;
  dj:=round(100*dk)/100;
  rc:=(em*cos(de*bm)*cos(ra*bm)-er*cos(breite*bm)*cos(15*sz*bm))/(bn*cos(dk*bm));
  rd:=arccos(rc)/bm;
  if ra>180 then rd:=360-rd;
  rk:=rd;
  rh:=int(rk/15);
  rma:=round(6000*(rk/15-rh))/100;
  sc:=180+(15*sz-rk);
  if sc<0 then sc:=sc+360;
  sd:=sc;
  if sd>360 then sd:=sd-360;
  sk:=sd;
  hc:=sin(breite*bm)*sin(dk*bm)+cos(breite*bm)*cos(dk*bm)*cos((180-sk)*bm);
  hk:=arcsin(hc)/bm;
  at:=(sin(dk*bm)-sin(breite*bm)*sin(hk*bm))/(cos(breite*bm)*cos(hk*bm));
  am:=arccos(at)/bm;
  if sk>180 then am:=360-am;
  azimut:=round(am);
  elevation:=hk;
  entfernung:=round(bi);
  anomalie:=0;
  orbit:=0;
  sspl:=sw;
  sspl:=180-sspl;
  while sspl<-180 do sspl:=sspl+360;
  sspb:=dj;
  sspr:=round(em-mr-er)
end;

function doy:extended;
{*********************
Eingabe: keine (hoechstens Systemzeit)
Ausgabe: Day Of Year (Anzahl der Tage seit 1.Januar mit genauer Uhrzeit als
         Nachkomma-Wert)
Umsetzung des Monats mittels Tabelle aus Geschwindigkeitsgruenden.
 *********************}
const mt : array[1..12] of word = (0,31,59,90,120,151,181,212,243,273,304,334);
var   zt : extended;
      jw : word;
begin
  zt:=mt[monat]+tag+rechnerzeit+zeitzone/24;
  if (monat>2) and (0=jahr and 3) and (jahr<>2000) then zt:=zt+1;
  doy:=zt
end;

function time:extended;
var i  : byte;
    jw : word;
begin
  jw:=jahr-1900;
  if jw>1999 then i:=1 else i:=0;
  time:=365*jw+((jw+3) DIV 4)+doy-i
end;

function amsattime(a:byte):extended;
{**********************
Eingabe: a (Nummer des Satelliten)
Ausgabe: Anzahl der Tage vom 1.1.1900 bis zum Zeitpunkt der Bahndaten
 **********************}
var ej : word;
    et, zg : extended;
begin
  ej:=round(satet[a]) div 1000;           {Epoche Jahr}
  if ej<80 then ej:=ej+100;               {Datum im 21. Jahrhundert!}
  et:=1000*frac(satet[a]/1000);           {Epoche Tag}
  zg:=et+365*ej+((ej+3) DIV 4)-satma[a]/(360*satmm[a]);  {Zeit Referenzperigum absolut}
  if ej>99 then zg:=zg-1;                 {2000 ist KEIN Schaltjahr!}
  amsattime:=zg
end;

procedure berech(a:byte);
{****************************************
Dies ist das Herzstueck des Programms, die eigendliche Berechnung
der Position des Satelliten Nr. a.
Die Daten werden dem Feld entnommen, das loaddata gefuellt hat.
Berechnet werden:
- Azimut und Elevation in Grad
- Subsatellitenpunkt (SSPL, SSPB) und Hoehe ueber Grund in km
- Anomalie in 256teln ab dem letzten Perigaeum
- Orbit-Nummer seit dem Start
- Squintwinkel in Grad
- Entfernung in km
Der Algorithmus stammt von Dr.Karl Meinzer/AMSAT-DL
und wurde in der CQ-DL 10/1985 S.577ff veroeffentlicht.
Die Squintwinkelberechnung stammt von DL1TV und wurde von ihm
im AMSAT-Journal 2/90 S.10ff veroeffentlicht.
 ****************************************}
var   zdx,zdy,zdz,zmm,za,zb,zc,zd,zh,zi,zsi,zci,zj,zk,zl,zm,zn,
      zo,zp,zq,zr,zs,zt,zu,zv,zw,zx,zy,zz,zlon,zlat,
      dv,tv,av,h1,h2,h3,h4,zaa,zda,zw1,zw2 : extended;

  procedure schleife(var zp,zr,zx,zy:extended);
  begin
    zr:=sqrt(zx*zx+zy*zy);
    if zx=0 then if zy<0 then zp:=-90 else zp:=90
    else begin
      zp:=arctan(zy/zx)/bm;
      if zx<=0 then if zy>0 then zp:=zp+180 else zp:=zp-180
    end
  end;

begin
  zdz:=breite*bm;
  if tref=0 then zt:=time else zt:=tref;
  zd:=zt-amsattime(a);                  {Differenzzeit seit Referenzperigaeum}
  zmm:=satmm[a]+satemm[a]*zd;           {akt. Mean Motion}
  zn:=pi2*zmm;                          {Winkelgeschw.}
  za:=42223*hoch(zmm,-2/3)/er;        {gr. Bahnhalbachse nach Kepler: U^2=T^3}
  zz:=hoch(za,3.5)*sqr(1-satecc[a]*satecc[a]);
  zi:=satincl[a]*bm;                      {Inkl. im Bogenmass}
  zsi:=sin(zi);                           {sin(inkl)}
  zci:=cos(zi);                           {cos(inkl)}
  zq:=-9.9999999999*zci/zz;               {dRAAN pro Tag}
  zv:=(25*zci*zci-5)/zz;                  {dArgPer pro Tag}
  zo:=satraan[a]+zd*zq;                   {aktueller RAAN}
  zw:=satargp[a]+zd*zv;                   {aktuelles ArgPer}
  zk:=zo-fp-zt*zf-laenge;                 {Laengendifferenz}
  zm:=zd*zn;                              {Differenzumlaeufe}
  zr:=satecc[a];                          {Naeherung nach Kepler}
  zp:=zm;                                 {im Bogenmass}
  repeat
    zh:=(zm-zp+zr*sin(zp))/(1-zr*cos(zp));
    zp:=zp+zh;
  until abs(zh)<1E-10;
  zy:=sin(zp)*sqrt(1-satecc[a]*satecc[a]);
  zx:=cos(zp)-satecc[a];
  schleife(zp,zr,zx,zy);
  zr:=za*zr;
  zp:=bm*(zp+zw);
  zy:=zr*sin(zp);
  zh:=zr*cos(zp);
  zp:=zi;
  zs:=zy*zsi;
  zx:=zy*zci;
  schleife(zp,zr,zh,zx);
  zp:=zp+zk;
  zk:=zp+laenge;
  zu:=zr;
  zp:=zp*bm;
  zh:=zr*sin(zp);
  zz:=zs-sin(zdz);
  zx:=zr*cos(zp)-cos(zdz);
  schleife(zp,zr,zx,zz);
  zp:=bm*(zp-breite+90);
  zj:=zr*sin(zp);
  zx:=zr*cos(zp);
  schleife(zp,zr,zx,zh);
  zc:=180-zp;
  azimut:=round(zc);
  zx:=zr;
  schleife(zp,zr,zx,zj);            {soweit Fertig}
  elevation:=zp;
  zm:=zm/pi2;                       {akt. Bahnpunkt}
  anomalie:=256*frac(zm);
  orbit:=trunc(zm)+satuml[a];
  zdx:=zp*bm;
  if (sataa[a]>0) or (satda[a]>0) then begin    {Squintwinkel}
    dv:=arcsin(sin(zdx)*sin(zdz)+cos(zdx)*cos(zdz)*cos(zc*bm));
    tv:=arccos((sin(zdx)-sin(zdz)*sin(dv))/(cos(zdz)*cos(dv)))/bm;
    if zc<180 then tv:=360-tv;
    av:=360+fp+(zf-360)*int(zt)+zf*frac(zt)+laenge-tv;
    squint:=round(arccos(sin(satda[a]*bm)*sin(dv)
            +cos(satda[a]*bm)*cos(dv)*cos((sataa[a]-av)*bm))/bm)
  end;                           
  zk:=360*frac(zk/360);             {SubSatellitenPunkt berechnen}
  schleife(zp,zr,zu,zs);
  if zk<-180 then zk:=zk+360;       {Anpassen fuer Ausgabe}
  if zk>180 then zk:=zk-360;
  sspl:=zk;
  sspb:=zp;
  sspe:=zr;
  sspr:=round(er*(zr-1));
  zdy:=cos(zdx);                    {Entfernung zum Satelliten}
  entfernung:=round(er*(sqrt(zr*zr-zdy*zdy)-sin(zdx)))
                      {Dreieck Sat-QTH-Erde mit Winkel Elevation...}
end;

procedure solephemeriden(dtime:extended);
{*************************************************
Eingaben: dtime (Zeitoffset)
Ausgaben: alphaSo, deltaSo (Sonnenstand),
          GrtWi (Greenwicher Winkel)
Grenzen:  1.1.1987 - 31.12.2000
vielen Dank an DL1TV, der diese Prozedur schrieb
 ************************************************* }

const l0      : array[1987..2000] of real =     (279.12820, 278.89110,
                                                 279.63952, 279.40202,
                                                 279.16409, 278.92566,
                                                 279.67233, 279.43286,
                                                 279.19296, 278.95277,
                                                 279.69811, 279.45787,
                                                 279.21786, 278.97823);

      g0      : array[1987..2000] of real     = (356.41766, 356.16176,
                                                 356.89147, 356.63557,
                                                 356.37968, 356.12378,
                                                 356.85349, 356.59759,
                                                 356.34170, 356.08580,
                                                 356.81551, 356.55962,
                                                 356.30372, 356.04783);

      e       : array[1987..2000] of real     = (0.0167146, 0.0167142,
                                                 0.0167137, 0.0167133,
                                                 0.0167129, 0.0167125,
                                                 0.0167121, 0.0167116,
                                                 0.0167112, 0.0167108,
                                                 0.0167104, 0.0167100,
                                                 0.0167095, 0.0167091);

      epsilon : array[1987..2000] of real     = (23.44350, 23.44333,
                                                 23.44288, 23.44218,
                                                 23.44130, 23.44033,
                                                 23.43935, 23.43847,
                                                 23.43777, 23.43732,
                                                 23.43714, 23.43725,
                                                 23.43762, 23.43819);

      grtw0   : array[1987..2000] of real     = (99.12766, 98.89041,
                                                 99.63870, 99.40109,
                                                 99.16309, 98.92463,
                                                 99.67131, 99.43189,
                                                 99.19208, 98.95201,
                                                 99.69747, 99.45734,
                                                 99.21743, 98.97787);

      Kd  : real = 0.9856473;    {Erddrehungen in Grad pro Tag minus 360 Grad}
      Kdg : real = 0.9856003;    {mit Bezug Himmel und Fixpunkt}
      Kt  : real = 15.04107;     {Erddrehung in Grad pro Stunde gegen Himmel}

var   j : word;
      s : string[5];
      Epoche, LSoStrich, LSo, g, taSo, sdSo,
      saa, dSbm, dAbm : extended;

begin
  Epoche:=Doy+dtime;
  j:=jahr;
  if (j>1986) and (j<2001) then begin

    g:=g0[j]+Kdg*Epoche;
    if g>360 then g:=g-360;
    LSoStrich:=L0[j]+Kd*Epoche;
    LSo:=LSoStrich+(2*E[j]*sin(g*bm)+1.25*sqr(E[j])*sin(2*g*bm))/bm;
    if LSo>360 then LSo:=LSo-360;

    if (LSo<>90) and (LSo<>270) then begin
      taSo:=sin(LSo*bm)*cos(Epsilon[j]*bm)/cos(LSo*bm);
      alphaSo:=arctan(taSo)/bm         { taSo:=tan(alphaSo*bm) }
    end else begin
      if LSo=90 then alphaSo:=90;
      if LSo=-90 then alphaSo:=-90
    end;
             { alpha im gleichen Quadranten wie LSo: }
    if cos(LSo*bm)<0 then alphaSo:=alphaSo+180        { II, III }
    else if alphaSo<0 then alphaSo:=alphaSo+360;        { IV }
    sdSo:=sin(LSo*bm)*sin(Epsilon[j]*bm);
    deltaSo:=arcsin(sdSo)/bm;          { sdSo:=sin(deltaSo*bm) }

    GrtWi:=GrtW0[j]+Kd*trunc(Epoche)+Kt*24*frac(Epoche);
    if GrtWi>360 then GrtWi:=GrtWi-360;
    if GrtWi>360 then GrtWi:=GrtWi-360;
  {
    GrtSo := GrtWi - alphaSo;
    if GrtSo<0 then GrtSo := GrtSo + 360;
  }
  end
end;
