TITLE ClearBlock3 (tested)
;Horizontale Linien in Ebene 3 (Koordinaten korrigiert)
code            segment	word
assume		cs:	code

public		ClearBlock3
public		HLine3

ClearBlock3:; Procedure ClearBlock3(y1,y2:integer);

; Lschen der Speicherebene 3 von Zeile y1 bis Zeile y2 der EGA/VGA-Karte im
; 16 Farb-Modus

y1	equ	[bp+6]
y2	equ	[bp+4]

push	bp
mov	bp,sp

mov	ax,40h
mov	es,ax

mov	si,es:[4Ah]	; Textspalten

mov	ax,0A000h
mov	es,ax

mov	ax,y1
mov	cx,y2
sub	cx,ax
inc	cx
mul	si
mov	di,ax		; ES:DI Anfangsadresse

mov	ax,cx
shr	si,1
mul	si
mov	cx,ax		; CX Anzahl an Wrtern

mov	dx,03C4h	; Sequenzer
mov	al,2		; Map-Mask
out	dx,al
inc	dx
mov	al,8h		; Ebene 3 aktiv
out	dx,al

cld
xor	ax,ax
rep	stosw		; Bildschirmebene lschen

mov	dx,03C4h	; clean up
mov	al,2
out	dx,al
inc	dx
mov	al,0Fh
out	dx,al

pop	bp
ret 4


HLine3:	; Procedure HLine3(x1,x2,y:integer;SetAtr:boolean);

	; Setzt von Zeile y1 bis Zeile y2 der EGA/VGA-Karte im
	; 16 Farb-Modus das Helligkeitsattribut, das in SetAtr steht.
	; x1 linkes Ende der Linie, gltiger Bereich 0..MaxX
	; x2 rechtes Ende der Linie, gltiger Bereich 0..MaxX	
	; y Zeile, gltiger Bereich 0..MaxY
	; MaxX,MaxY : Bildschirmauflsung-1 in dem aktiven Graphik-Modus

x1	equ 	[bp+10]	; Parameteradressen
x2	equ 	[bp+8]
y	equ 	[bp+6]
SetAtr	equ 	byte ptr [bp+4]

push	bp
mov	bp,sp
; -------------------------------
mov	ax,40h			; Bios-Variablensegment
mov	es,ax
mov	ax,y
mul	word	ptr es:[4Ah] 	; Anzahl Textspalten meistens 80
mov	di,ax			; DI = Zeilenoffset im Videospeicher
; -------------------------------
mov	ax,0A000h
mov	es,ax			; ES = Bildschirmsegment
; -------------------------------
mov	ax,x1
mov	dx,x2

cmp	ax,dx			; prfen der Bereichsgrenzen
jnl	@@ende			; wenn nicht x1<x2 dann abbrechen

@@t:
mov	bx,ax			; AX = BX = x1
mov	si,dx			; DX = SI = x2
; -------------------------------
mov	cl,3
shr	ax,cl			; AX = x1 / 8
shr	dx,cl			; DX = x1 / 8
; -------------------------------
add	di,ax			; ES:DI Bildschirmadresse
; -------------------------------
sub	dx,ax
mov	cx,dx			; CX = Breite in Byte - 1
; -------------------------------
and	bx,7
mov	bl,cs:Atab[bx]		; BL = Anfangsmaske Linie
and	si,7
mov	bh,cs:Etab[si]		; BH = Endmaske Linie
; -------------------------------
mov	dx,03C4h
mov	ax,0802h		; Schreiben : Ebene 3
out	dx,ax

mov	dx,03CEh
mov	ax,0304h		; Lesen : Ebene 3
out	dx,ax
; -------------------------------
cmp	SetAtr,0		; lschen oder setzen
je	@@clear

jcxz	@@1s			; Lnge = 0 : nur ein Byte

or	es:[di],bl		; Anfangsmaske ausgeben
inc	di			; Adresse nchstes Bildschirmbyte
dec	cx			; Gesamtbreite kleiner/gleich 1
jz	@@2s			; keine Fllbytes

cld				; Fllen
mov	al,0FFh
rep	stosb

@@2s:
or	es:[di],bh		; Endmaske
jmp	@@q
; -------------------------------
@@1s:
and	bl,bh			; bei einem Byte Masken verknpfen
or	es:[di],bl
jmp	@@q

; -------------------------------
@@clear:			; Lschen
jcxz	@@1			; nur ein Byte

not	bl
and	es:[di],bl		; Anfangsbyte ausgeben
inc	di
dec	cx
jz	@@2			; keine Fllbytes

cld				; Fllen
xor	al,al
rep	stosb

@@2:
not	bh
and	es:[di],bh		; Endbyte
jmp	@@q
; -------------------------------
@@1:
and	bl,bh			; bei einem Byte Masken verknpfen
not	bl
and	es:[di],bl
@@q:
; -------------------------------
mov	dx,03C4h
mov	ax,0FF02h		; Schreiben : alle Ebenen
out	dx,ax
; -------------------------------
@@ende:
pop	bp
ret	8

Atab DB 0FFh,7Fh,3Fh,1Fh,0Fh,07h,03h,01h; Pixelmasken
Etab DB 080h,0C0h,0E0h,0F0h,0F8h,0FCh,0FEh,0FFh

code	ends
end
